<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>IOUtils.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.common</a> &gt; <span class="el_source">IOUtils.java</span></div><h1>IOUtils.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.common;

import java.io.Closeable;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;

import org.slf4j.Logger;

/*
 * This code is originally from HDFS, see the similarly named files there
 * in case of bug fixing, history, etc...
 */

<span class="nc" id="L33">public class IOUtils {</span>
    /**
     * Closes the stream ignoring {@link IOException}. Must only be called in
     * cleaning up from exception handlers.
     * 
     * @param stream
     *            the Stream to close
     */
    public static void closeStream(Closeable stream) {
<span class="fc" id="L42">        cleanup(null, stream);</span>
<span class="fc" id="L43">    }</span>

    /**
     * Close the Closeable objects and &lt;b&gt;ignore&lt;/b&gt; any {@link IOException} or
     * null pointers. Must only be used for cleanup in exception handlers.
     * 
     * @param log
     *            the log to record problems to at debug level. Can be null.
     * @param closeables
     *            the objects to close
     */
    public static void cleanup(Logger log, Closeable... closeables) {
<span class="fc bfc" id="L55" title="All 2 branches covered.">        for (Closeable c : closeables) {</span>
<span class="fc bfc" id="L56" title="All 2 branches covered.">            if (c != null) {</span>
                try {
<span class="fc" id="L58">                    c.close();</span>
<span class="nc" id="L59">                } catch (IOException e) {</span>
<span class="nc bnc" id="L60" title="All 2 branches missed.">                    if (log != null) {</span>
<span class="nc" id="L61">                        log.warn(&quot;Exception in closing &quot; + c, e);</span>
                    }
<span class="fc" id="L63">                }</span>
            }
        }
<span class="fc" id="L66">    }</span>

    /**
     * Copies from one stream to another.
     * 
     * @param in
     *            InputStrem to read from
     * @param out
     *            OutputStream to write to
     * @param buffSize
     *            the size of the buffer
     * @param close
     *            whether or not close the InputStream and OutputStream at the
     *            end. The streams are closed in the finally clause.
     */
    public static void copyBytes(InputStream in, OutputStream out,
            int buffSize, boolean close) throws IOException {
        try {
<span class="fc" id="L84">            copyBytes(in, out, buffSize);</span>
<span class="pc bpc" id="L85" title="1 of 2 branches missed.">            if (close) {</span>
<span class="fc" id="L86">                out.close();</span>
<span class="fc" id="L87">                out = null;</span>
<span class="fc" id="L88">                in.close();</span>
<span class="fc" id="L89">                in = null;</span>
            }
<span class="fc" id="L91">        } finally {</span>
<span class="nc" id="L92">            if (close) {</span>
<span class="pc" id="L93">                closeStream(out);</span>
<span class="pc bnc" id="L94" title="All 2 branches missed.">                closeStream(in);</span>
            }
<span class="fc" id="L96">        }</span>
<span class="pc bpc" id="L97" title="1 of 2 branches missed.">    }</span>

    /**
     * Copies from one stream to another.
     * 
     * @param in
     *            InputStrem to read from
     * @param out
     *            OutputStream to write to
     * @param buffSize
     *            the size of the buffer
     */
    public static void copyBytes(InputStream in, OutputStream out, int buffSize)
            throws IOException {
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">        PrintStream ps = out instanceof PrintStream ? (PrintStream) out : null;</span>
<span class="fc" id="L112">        byte buf[] = new byte[buffSize];</span>
<span class="fc" id="L113">        int bytesRead = in.read(buf);</span>
<span class="fc bfc" id="L114" title="All 2 branches covered.">        while (bytesRead &gt;= 0) {</span>
<span class="fc" id="L115">            out.write(buf, 0, bytesRead);</span>
<span class="pc bpc" id="L116" title="3 of 4 branches missed.">            if ((ps != null) &amp;&amp; ps.checkError()) {</span>
<span class="nc" id="L117">                throw new IOException(&quot;Unable to write to output stream.&quot;);</span>
            }
<span class="fc" id="L119">            bytesRead = in.read(buf);</span>
        }
<span class="fc" id="L121">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>